package io.skore.video360kaltura

import VideoViewFactory
import androidx.annotation.NonNull;
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar

/** Video360kalturaPlugin */
public class Video360kalturaPlugin: FlutterPlugin, MethodCallHandler {
  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    val channel = MethodChannel(flutterPluginBinding.binaryMessenger, "video360Kaltura")
    channel.setMethodCallHandler(Video360kalturaPlugin());
    flutterPluginBinding.platformViewRegistry.registerViewFactory("plugins.video_360_kaltura/player_view", VideoViewFactory(flutterPluginBinding.binaryMessenger))
  }

  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "video360Kaltura")
      channel.setMethodCallHandler(Video360kalturaPlugin())

      registrar.platformViewRegistry()
              .registerViewFactory("plugins.video_360_kaltura/player_view", VideoViewFactory(registrar.messenger()));
    }
  }

  override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {
    if (call.method == "getPlatformVersion") {
      result.success("Android ${android.os.Build.VERSION.RELEASE}")
    } else {
      result.notImplemented()
    }
  }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
  }
}
